package com.engine.htsc.collaboration.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.collaboration.service.WorkflowTaskService;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * create by PTY
 */
public class WorkflowTaskAction {

    WorkflowTaskService getService(){
        return ServiceUtil.getService(WorkflowTaskService.class);
    }

    @POST
    @Path("/createFromImportantMatters")
    @Produces({MediaType.TEXT_PLAIN})
    public String createFromImportantMatters(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            User user = HrmUserVarify.getUser(request, response);
            String requestid = request.getParameter("requestid");

            WorkflowTaskService workflowTaskService = getService();
            apidatas = workflowTaskService.createFromImportantMatters(user,requestid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/createFromReceipt")
    @Produces({MediaType.TEXT_PLAIN})
    public String createFromReceipt(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            String requestid = request.getParameter("requestid");

            WorkflowTaskService workflowTaskService = getService();
            apidatas = workflowTaskService.createFromReceipt(requestid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/createFromSubImportantMatters")
    @Produces({MediaType.TEXT_PLAIN})
    public String createFromSubImportantMatters(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            User user = HrmUserVarify.getUser(request, response);
            String requestid = request.getParameter("requestid");

            WorkflowTaskService workflowTaskService = getService();
            apidatas = workflowTaskService.createFromSubImportantMatters(user,requestid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/createfromothertask")
    @Produces({MediaType.TEXT_PLAIN})
    public String createfromothertask(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            User user = HrmUserVarify.getUser(request, response);
            String requestid = request.getParameter("requestid");

            WorkflowTaskService workflowTaskService = getService();
            apidatas = workflowTaskService.createfromothertask(user,requestid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }
}
