package com.engine.htsc.coworkreport.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.coworkreport.service.CoWorkReportService;
import com.engine.htsc.coworkreport.service.impl.CoWorkReportServiceImpl;
import com.engine.htsc.mhjc.service.HtscMhjcService;
import com.engine.htsc.mhjc.service.impl.HtscMhjcServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/***
 *
 */
public class CoWorkReportAction {

    public CoWorkReportService getService(){
        return ServiceUtil.getService(CoWorkReportServiceImpl.class);
    }

    @GET
    @Path("/reportlist")
    @Produces({MediaType.TEXT_PLAIN})
    public String ReportList(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            User user = HrmUserVarify.getUser(request, response);
            Map<String,Object> param = ParamUtil.request2Map(request);
            CoWorkReportService coWorkReportService = getService();
            apidatas = coWorkReportService.getreportList(param,user);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }
        return JSON.toJSONString(apidatas);
    }


    @GET
    @Path("/dynamicslist")
    @Produces({MediaType.TEXT_PLAIN})
    public String dynamicsList(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            User user = HrmUserVarify.getUser(request, response);
            Map<String,Object> param = ParamUtil.request2Map(request);
            CoWorkReportService coWorkReportService = getService();
            apidatas = coWorkReportService.getdynamicsList(param,user);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }
        return JSON.toJSONString(apidatas);
    }
}
