package com.engine.htsc.coworkreport.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.coworkreport.service.TaskMessageService;
import com.engine.htsc.coworkreport.service.impl.TaskMessageServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/***
 *
 */
public class TaskMessageAction {

    public TaskMessageService getService(){
        return ServiceUtil.getService(TaskMessageServiceImpl.class);
    }

    @GET
    @Path("/sendmessage")
    @Produces({MediaType.TEXT_PLAIN})
    public String SendMessage(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            User user = HrmUserVarify.getUser(request, response);
            Map<String,Object> param = ParamUtil.request2Map(request);
            TaskMessageService taskMessageService = getService();
            apidatas = taskMessageService.sendMessage(param,user);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("status","0");
            apidatas.put("message","发送提醒异常");
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }
        return JSON.toJSONString(apidatas);
    }

}
