package com.engine.htsc.lhqssp.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.lhqssp.service.LhqsspService;
import com.engine.htsc.lhqssp.service.impl.LhqsspServiceImpl;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName LhqssqAction
 * @Author K1810015
 * @Date 2022/3/1 10:29
 * Version 1.0
 */
public class LhqsspAction {

    private LhqsspService getlhqssqservice(){
       return  ServiceUtil.getService(LhqsspServiceImpl.class);
    }

    @POST
    @Path("/checkCoDirectorNotice")
    @Produces({MediaType.TEXT_PLAIN})
    public String checkCoDirectorNotice(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----UnionSealApplicationAction-----");
        try{
            String requestid = request.getParameter("requestid");
            String nodename = request.getParameter("nodename");
            apidatas = getlhqssqservice().checkCoDirectorNotice(requestid,nodename);
        }catch (Exception                e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/noticeSignDeptCoDirector")
    @Produces({MediaType.TEXT_PLAIN})
    public String noticeSignDeptCoDirector(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----UnionSealApplicationAction-----");
        try{
            String requestid = request.getParameter("requestid");
            String nodeid = request.getParameter("nodeid");
            String deptid = request.getParameter("deptid");
            apidatas = getlhqssqservice().noticeSignDeptCoDirector(requestid,nodeid,deptid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    //获取已送的
    @POST
    @Path("/getdoneworkflow")
    @Produces({MediaType.TEXT_PLAIN})
    public String getdoneworkflow(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----UnionSealApplicationAction-----");
        try{
            apidatas = getlhqssqservice().workflowdone(ParamUtil.request2Map(request));
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }


}
