package com.engine.htsc.payment.enums;

import org.apache.commons.lang3.StringUtils;

public enum BudgetWF {

	//总部通用付款
	PAYMENT("1", "com.engine.htsc.payment.service.impl.HeadPaymentBudgetStrategy"),

	//总部通用报销
	BXBUDGET("2", "com.engine.htsc.payment.service.impl.HeadBxBudgetStrategy"),

	//总部通用差旅报销
	CLBXBUDGET("3", "com.engine.htsc.payment.service.impl.HeadClBxBudgetStrategy"),

	//紫金通用报销
	ZJBXBUDGET("4","com.engine.htsc.payment.service.impl.ZjBxBudgetStrategy"),

	//采购商城通用付款
	CGSCPAYMENT("5","com.engine.htsc.payment.service.impl.HeadCgscPaymentBudgetStrategy");


	private String code;
	private String className;

	BudgetWF() {
	}

	BudgetWF(String code, String className) {
		this.code = code;
		this.className = className;
	}

	public static String getClassNameByCode(String code) {
		String className = "";
		if (StringUtils.isEmpty(code)) {
			return className;
		}

		for (BudgetWF e : BudgetWF.values()) {
			if (e.code.equalsIgnoreCase(code)) {
				className = e.className;
				break;
			}
		}
		return className;
	}

	public String getCode() {
		return code;
	}

	public String getClassName() {
		return className;
	}
}
