package com.engine.htsc.payment.pojo;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.List;

/**
 * 核算请求数据封装
 */
public class CostAccountDto implements Serializable {
	private static final long serialVersionUID = -6198697112629171860L;

	//是否全电子
	@JSONField(name = "sfqdz")
	private String electronicBill;

	//类别
	@JSONField(name = "lb")
	private String type;

	//拟稿人部门名称
	@JSONField(name = "bxbm")
	private String ngrDept;

	//拟稿人部门编号
	@JSONField(name = "bxbmbh")
	private String ngrDeptCode;

	//拟稿人姓名
	@JSONField(name = "bxr")
	private String ngrName;

	//流程编号
	@JSONField(name = "bxbh")
	private String requestMark;

	//流程id
	@JSONField(name = "djid")
	private String requestId;

	//附件张数
	@JSONField(name = "fjzs")
	private String attachmentNum;

	//报销地点(中文)
	@JSONField(name = "dq")
	private String locationName;

	//流程标题
	@JSONField(name = "zy")
	private String title;

	//币种
	@JSONField(name = "bz")
	private String currency;

	//拟稿日期(yyyy-MM-dd HH:mm:ss)
	@JSONField(name = "ngrq")
	private String createDate;

	//报销方式
	@JSONField(name = "bxfs")
	private String reimbursementWay;

	//付款单号
	@JSONField(name = "fkdh")
	private String payOrderNo;

	//项目编号
	private String bh1;
	//项目名称
	private String bz1;
	private String bz2;

	@JSONField(name = "sfyfp")
	private String sfyfp;

	//会计明细
	@JSONField(name = "kjmx")
	private List<KjDetail> kjDetails;

	//支付明细
	@JSONField(name = "zfmx")
	private List<PayDetail> payDetails;

	//单据数量
	@JSONField(name = "djsl")
	private String djsl;

	//纸质单据数量
	@JSONField(name = "zzdjsl")
	private String zzdjsl;

	public CostAccountDto() {
	}

	public CostAccountDto(String electronicBill, String type, String ngrDept, String ngrDeptCode, String ngrName, String requestMark, String requestId, String attachmentNum, String locationName, String title, String currency, String createDate, String reimbursementWay, String payOrderNo, String bh1, String bz1, String bz2, List<KjDetail> kjDetails, List<PayDetail> payDetails, String djsl, String zzdjsl) {
		this.electronicBill = electronicBill;
		this.type = type;
		this.ngrDept = ngrDept;
		this.ngrDeptCode = ngrDeptCode;
		this.ngrName = ngrName;
		this.requestMark = requestMark;
		this.requestId = requestId;
		this.attachmentNum = attachmentNum;
		this.locationName = locationName;
		this.title = title;
		this.currency = currency;
		this.createDate = createDate;
		this.reimbursementWay = reimbursementWay;
		this.payOrderNo = payOrderNo;
		this.bh1 = bh1;
		this.bz1 = bz1;
		this.bz2 = bz2;
		this.kjDetails = kjDetails;
		this.payDetails = payDetails;
		this.djsl = djsl;
		this.zzdjsl = zzdjsl;
	}

	public String getElectronicBill() {
		return electronicBill;
	}

	public void setElectronicBill(String electronicBill) {
		this.electronicBill = electronicBill;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getNgrDept() {
		return ngrDept;
	}

	public void setNgrDept(String ngrDept) {
		this.ngrDept = ngrDept;
	}

	public String getNgrName() {
		return ngrName;
	}

	public void setNgrName(String ngrName) {
		this.ngrName = ngrName;
	}

	public String getRequestMark() {
		return requestMark;
	}

	public void setRequestMark(String requestMark) {
		this.requestMark = requestMark;
	}

	public String getRequestId() {
		return requestId;
	}

	public void setRequestId(String requestId) {
		this.requestId = requestId;
	}

	public String getAttachmentNum() {
		return attachmentNum;
	}

	public void setAttachmentNum(String attachmentNum) {
		this.attachmentNum = attachmentNum;
	}

	public String getLocationName() {
		return locationName;
	}

	public void setLocationName(String locationName) {
		this.locationName = locationName;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getCurrency() {
		return currency;
	}

	public void setCurrency(String currency) {
		this.currency = currency;
	}

	public String getCreateDate() {
		return createDate;
	}

	public void setCreateDate(String createDate) {
		this.createDate = createDate;
	}

	public String getReimbursementWay() {
		return reimbursementWay;
	}

	public void setReimbursementWay(String reimbursementWay) {
		this.reimbursementWay = reimbursementWay;
	}

	public String getPayOrderNo() {
		return payOrderNo;
	}

	public void setPayOrderNo(String payOrderNo) {
		this.payOrderNo = payOrderNo;
	}

	public List<KjDetail> getKjDetails() {
		return kjDetails;
	}

	public void setKjDetails(List<KjDetail> kjDetails) {
		this.kjDetails = kjDetails;
	}

	public List<PayDetail> getPayDetails() {
		return payDetails;
	}

	public void setPayDetails(List<PayDetail> payDetails) {
		this.payDetails = payDetails;
	}

	public String getNgrDeptCode() {
		return ngrDeptCode;
	}

	public void setNgrDeptCode(String ngrDeptCode) {
		this.ngrDeptCode = ngrDeptCode;
	}

	public String getBh1() {
		return bh1;
	}

	public void setBh1(String bh1) {
		this.bh1 = bh1;
	}

	public String getBz1() {
		return bz1;
	}

	public void setBz1(String bz1) {
		this.bz1 = bz1;
	}

	public String getBz2() {
		return bz2;
	}

	public void setBz2(String bz2) {
		this.bz2 = bz2;
	}

	public String getSFYFP() {
		return sfyfp;
	}

	public void setSFYFP(String SFYFP) {
		this.sfyfp = SFYFP;
	}

	public String getDjsl() {
		return djsl;
	}

	public void setDjsl(String djsl) {
		this.djsl = djsl;
	}

	public String getZzdjsl() {
		return zzdjsl;
	}

	public void setZzdjsl(String zzdjsl) {
		this.zzdjsl = zzdjsl;
	}

	@Override
	public String toString() {
		return "CostAccountDto{" +
				"electronicBill='" + electronicBill + '\'' +
				", type='" + type + '\'' +
				", ngrDept='" + ngrDept + '\'' +
				", ngrDeptCode='" + ngrDeptCode + '\'' +
				", ngrName='" + ngrName + '\'' +
				", requestMark='" + requestMark + '\'' +
				", requestId='" + requestId + '\'' +
				", attachmentNum='" + attachmentNum + '\'' +
				", locationName='" + locationName + '\'' +
				", title='" + title + '\'' +
				", currency='" + currency + '\'' +
				", createDate='" + createDate + '\'' +
				", reimbursementWay='" + reimbursementWay + '\'' +
				", payOrderNo='" + payOrderNo + '\'' +
				", bh1='" + bh1 + '\'' +
				", bz1='" + bz1 + '\'' +
				", bz2='" + bz2 + '\'' +
				", kjDetails=" + kjDetails +
				", payDetails=" + payDetails +
				", djsl='" + djsl + '\'' +
				", zzdjsl='" + zzdjsl + '\'' +
				'}';
	}
}
