package com.engine.htsc.payment.service;

import java.io.File;
import java.util.List;
import java.util.Map;

public interface PaymentCommonService {

  /**
   * 流程附件下载
   */
  File buildAttachmentsZipFile() throws Exception;

  /**
   * 更新合同信息
   * @param rids 流程id 例如 1,2
   * @return 接口返回信息
   */
  String syncContractInfo(String syncIt, String rids) throws Exception;

  /**
   * 接收到流程编号后自动写预算实占、核算并且将预算状态、核算状态、付款状态改为已经同步、已经付款
   *
   * @param requestId 网报流程id
   */
  List<Map<String, String>> syncFundAllStatus(String requestId) throws Exception;
}
