package com.engine.htsc.seal.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.seal.service.CxSealApplicationService;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

public class CxSealApplicationAction {

    CxSealApplicationService getService(){
        return ServiceUtil.getService(CxSealApplicationService.class);
    }

    @POST
    @Path("/getDept")
    @Produces({MediaType.TEXT_PLAIN})
    public String getDept(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----CxSealApplicationAction-----");
        try{
            String yz = request.getParameter("yz");
            String wjlb = request.getParameter("wjlb");
            String wjlx = request.getParameter("wjlx");
            String szbm = request.getParameter("szbm");

            CxSealApplicationService service = getService();
            apidatas = service.getDeptBySealAndFileType(yz,wjlb,wjlx,szbm);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/getCommonSeal")
    @Produces({MediaType.TEXT_PLAIN})
    public String getCommonSeal(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----CxSealApplicationAction-----");
        try{
            String szbm = request.getParameter("szbm");

            CxSealApplicationService service = getService();
            apidatas = service.getCommonSeal(szbm);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }
}
